# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
"""
This file contains the exact signatures for all functions in module
PySide6.Qt3DRender, except for defaults which are replaced by "...".
"""

# mypy: disable-error-code="override, overload-overlap"
# Module `PySide6.Qt3DRender`

import PySide6.Qt3DRender
import PySide6.QtCore
import PySide6.Qt3DCore

import enum
import typing
import collections.abc
from PySide6.QtCore import Signal
from shiboken6 import Shiboken


class QIntList: ...


class Qt3DRender(Shiboken.Object):

    class API(enum.Enum):

        OpenGL                    = 0x0
        Vulkan                    = 0x1
        DirectX                   = 0x2
        Metal                     = 0x3
        RHI                       = 0x4
        Null                      = 0x5

    class PropertyReaderInterface(Shiboken.Object): ...

    class PropertyReaderInterfacePtr(Shiboken.Object): ...
        def __dir__(self, /) -> collections.abc.Iterable[str]: ...
        def __repr__(self, /) -> str: ...

    class QAbstractLight(PySide6.Qt3DCore.Qt3DCore.QComponent):

        colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
        intensityChanged         : typing.ClassVar[Signal] = ... # intensityChanged(float)

        class Type(enum.Enum):

            PointLight                = 0x0
            DirectionalLight          = 0x1
            SpotLight                 = 0x2


    class QAbstractRayCaster(PySide6.Qt3DCore.Qt3DCore.QComponent):

        filterModeChanged        : typing.ClassVar[Signal] = ... # filterModeChanged(Qt3DRender::QAbstractRayCaster::FilterMode)
        hitsChanged              : typing.ClassVar[Signal] = ... # hitsChanged(Qt3DRender::QAbstractRayCaster::Hits)
        runModeChanged           : typing.ClassVar[Signal] = ... # runModeChanged(Qt3DRender::QAbstractRayCaster::RunMode)

        class FilterMode(enum.Enum):

            AcceptAnyMatchingLayers   = 0x0
            AcceptAllMatchingLayers   = 0x1
            DiscardAnyMatchingLayers  = 0x2
            DiscardAllMatchingLayers  = 0x3

        class RunMode(enum.Enum):

            Continuous                = 0x0
            SingleShot                = 0x1


    class QAbstractTexture(PySide6.Qt3DCore.Qt3DCore.QNode):

        comparisonFunctionChanged: typing.ClassVar[Signal] = ... # comparisonFunctionChanged(ComparisonFunction)
        comparisonModeChanged    : typing.ClassVar[Signal] = ... # comparisonModeChanged(ComparisonMode)
        depthChanged             : typing.ClassVar[Signal] = ... # depthChanged(int)
        formatChanged            : typing.ClassVar[Signal] = ... # formatChanged(TextureFormat)
        generateMipMapsChanged   : typing.ClassVar[Signal] = ... # generateMipMapsChanged(bool)
        handleChanged            : typing.ClassVar[Signal] = ... # handleChanged(QVariant)
        handleTypeChanged        : typing.ClassVar[Signal] = ... # handleTypeChanged(HandleType)
        heightChanged            : typing.ClassVar[Signal] = ... # heightChanged(int)
        layersChanged            : typing.ClassVar[Signal] = ... # layersChanged(int)
        magnificationFilterChanged: typing.ClassVar[Signal] = ... # magnificationFilterChanged(Filter)
        maximumAnisotropyChanged : typing.ClassVar[Signal] = ... # maximumAnisotropyChanged(float)
        minificationFilterChanged: typing.ClassVar[Signal] = ... # minificationFilterChanged(Filter)
        mipLevelsChanged         : typing.ClassVar[Signal] = ... # mipLevelsChanged(int)
        samplesChanged           : typing.ClassVar[Signal] = ... # samplesChanged(int)
        statusChanged            : typing.ClassVar[Signal] = ... # statusChanged(Status)
        widthChanged             : typing.ClassVar[Signal] = ... # widthChanged(int)

        class ComparisonFunction(enum.Enum):

            CompareNever              = 0x200
            CompareLess               = 0x201
            CompareEqual              = 0x202
            CompareLessEqual          = 0x203
            CompareGreater            = 0x204
            CommpareNotEqual          = 0x205
            CompareGreaterEqual       = 0x206
            CompareAlways             = 0x207

        class ComparisonMode(enum.Enum):

            CompareNone               = 0x0
            CompareRefToTexture       = 0x884e

        class CubeMapFace(enum.Enum):

            CubeMapPositiveX          = 0x8515
            CubeMapNegativeX          = 0x8516
            CubeMapPositiveY          = 0x8517
            CubeMapNegativeY          = 0x8518
            CubeMapPositiveZ          = 0x8519
            CubeMapNegativeZ          = 0x851a
            AllFaces                  = 0x851b

        class Filter(enum.Enum):

            Nearest                   = 0x2600
            Linear                    = 0x2601
            NearestMipMapNearest      = 0x2700
            LinearMipMapNearest       = 0x2701
            NearestMipMapLinear       = 0x2702
            LinearMipMapLinear        = 0x2703

        class HandleType(enum.Enum):

            NoHandle                  = 0x0
            OpenGLTextureId           = 0x1
            RHITextureId              = 0x2

        class Status(enum.Enum):

            None_                     = 0x0
            Loading                   = 0x1
            Ready                     = 0x2
            Error                     = 0x3

        class Target(enum.Enum):

            TargetAutomatic           = 0x0
            Target1D                  = 0xde0
            Target2D                  = 0xde1
            Target3D                  = 0x806f
            TargetRectangle           = 0x84f5
            TargetCubeMap             = 0x8513
            Target1DArray             = 0x8c18
            Target2DArray             = 0x8c1a
            TargetBuffer              = 0x8c2a
            TargetCubeMapArray        = 0x9009
            Target2DMultisample       = 0x9100
            Target2DMultisampleArray  = 0x9102

        class TextureFormat(enum.Enum):

            NoFormat                  = 0x0
            Automatic                 = 0x1
            DepthFormat               = 0x1902
            AlphaFormat               = 0x1906
            RGBFormat                 = 0x1907
            RGBAFormat                = 0x1908
            LuminanceFormat           = 0x1909
            LuminanceAlphaFormat      = 0x190a
            RG3B2                     = 0x2a10
            RGB8_UNorm                = 0x8051
            RGB16_UNorm               = 0x8054
            RGBA4                     = 0x8056
            RGB5A1                    = 0x8057
            RGBA8_UNorm               = 0x8058
            RGB10A2                   = 0x8059
            RGBA16_UNorm              = 0x805b
            D16                       = 0x81a5
            D24                       = 0x81a6
            D32                       = 0x81a7
            R8_UNorm                  = 0x8229
            R16_UNorm                 = 0x822a
            RG8_UNorm                 = 0x822b
            RG16_UNorm                = 0x822c
            R16F                      = 0x822d
            R32F                      = 0x822e
            RG16F                     = 0x822f
            RG32F                     = 0x8230
            R8I                       = 0x8231
            R8U                       = 0x8232
            R16I                      = 0x8233
            R16U                      = 0x8234
            R32I                      = 0x8235
            R32U                      = 0x8236
            RG8I                      = 0x8237
            RG8U                      = 0x8238
            RG16I                     = 0x8239
            RG16U                     = 0x823a
            RG32I                     = 0x823b
            RG32U                     = 0x823c
            RGB_DXT1                  = 0x83f0
            RGBA_DXT1                 = 0x83f1
            RGBA_DXT3                 = 0x83f2
            RGBA_DXT5                 = 0x83f3
            RGBA32F                   = 0x8814
            RGB32F                    = 0x8815
            RGBA16F                   = 0x881a
            RGB16F                    = 0x881b
            D24S8                     = 0x88f0
            RG11B10F                  = 0x8c3a
            RGB9E5                    = 0x8c3d
            SRGB8                     = 0x8c41
            SRGB8_Alpha8              = 0x8c43
            SRGB_DXT1                 = 0x8c4c
            SRGB_Alpha_DXT1           = 0x8c4d
            SRGB_Alpha_DXT3           = 0x8c4e
            SRGB_Alpha_DXT5           = 0x8c4f
            D32F                      = 0x8cac
            D32FS8X24                 = 0x8cad
            R5G6B5                    = 0x8d62
            RGB8_ETC1                 = 0x8d64
            RGBA32U                   = 0x8d70
            RGB32U                    = 0x8d71
            RGBA16U                   = 0x8d76
            RGB16U                    = 0x8d77
            RGBA8U                    = 0x8d7c
            RGB8U                     = 0x8d7d
            RGBA32I                   = 0x8d82
            RGB32I                    = 0x8d83
            RGBA16I                   = 0x8d88
            RGB16I                    = 0x8d89
            RGBA8I                    = 0x8d8e
            RGB8I                     = 0x8d8f
            R_ATI1N_UNorm             = 0x8dbb
            R_ATI1N_SNorm             = 0x8dbc
            RG_ATI2N_UNorm            = 0x8dbd
            RG_ATI2N_SNorm            = 0x8dbe
            RGB_BP_UNorm              = 0x8e8c
            SRGB_BP_UNorm             = 0x8e8d
            RGB_BP_SIGNED_FLOAT       = 0x8e8e
            RGB_BP_UNSIGNED_FLOAT     = 0x8e8f
            R8_SNorm                  = 0x8f94
            RG8_SNorm                 = 0x8f95
            RGB8_SNorm                = 0x8f96
            RGBA8_SNorm               = 0x8f97
            R16_SNorm                 = 0x8f98
            RG16_SNorm                = 0x8f99
            RGB16_SNorm               = 0x8f9a
            RGBA16_SNorm              = 0x8f9b
            RGB10A2U                  = 0x906f
            R11_EAC_UNorm             = 0x9270
            R11_EAC_SNorm             = 0x9271
            RG11_EAC_UNorm            = 0x9272
            RG11_EAC_SNorm            = 0x9273
            RGB8_ETC2                 = 0x9274
            SRGB8_ETC2                = 0x9275
            RGB8_PunchThrough_Alpha1_ETC2 = 0x9276
            SRGB8_PunchThrough_Alpha1_ETC2 = 0x9277
            RGBA8_ETC2_EAC            = 0x9278
            SRGB8_Alpha8_ETC2_EAC     = 0x9279


    class QAbstractTextureImage(PySide6.Qt3DCore.Qt3DCore.QNode):

        faceChanged              : typing.ClassVar[Signal] = ... # faceChanged(QAbstractTexture::CubeMapFace)
        layerChanged             : typing.ClassVar[Signal] = ... # layerChanged(int)
        mipLevelChanged          : typing.ClassVar[Signal] = ... # mipLevelChanged(int)

    class QAlphaCoverage(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QAlphaTest(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        alphaFunctionChanged     : typing.ClassVar[Signal] = ... # alphaFunctionChanged(AlphaFunction)
        referenceValueChanged    : typing.ClassVar[Signal] = ... # referenceValueChanged(float)

        class AlphaFunction(enum.Enum):

            Never                     = 0x200
            Less                      = 0x201
            Equal                     = 0x202
            LessOrEqual               = 0x203
            Greater                   = 0x204
            NotEqual                  = 0x205
            GreaterOrEqual            = 0x206
            Always                    = 0x207


    class QBlendEquation(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        blendFunctionChanged     : typing.ClassVar[Signal] = ... # blendFunctionChanged(BlendFunction)

        class BlendFunction(enum.Enum):

            Add                       = 0x8006
            Min                       = 0x8007
            Max                       = 0x8008
            Subtract                  = 0x800a
            ReverseSubtract           = 0x800b


    class QBlendEquationArguments(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        bufferIndexChanged       : typing.ClassVar[Signal] = ... # bufferIndexChanged(int)
        destinationAlphaChanged  : typing.ClassVar[Signal] = ... # destinationAlphaChanged(Blending)
        destinationRgbChanged    : typing.ClassVar[Signal] = ... # destinationRgbChanged(Blending)
        destinationRgbaChanged   : typing.ClassVar[Signal] = ... # destinationRgbaChanged(Blending)
        sourceAlphaChanged       : typing.ClassVar[Signal] = ... # sourceAlphaChanged(Blending)
        sourceRgbChanged         : typing.ClassVar[Signal] = ... # sourceRgbChanged(Blending)
        sourceRgbaChanged        : typing.ClassVar[Signal] = ... # sourceRgbaChanged(Blending)

        class Blending(enum.Enum):

            Zero                      = 0x0
            One                       = 0x1
            SourceColor               = 0x300
            OneMinusSourceColor       = 0x301
            SourceAlpha               = 0x302
            OneMinusSourceAlpha       = 0x303
            Source1Alpha              = 0x303
            DestinationAlpha          = 0x304
            Source1Color              = 0x304
            OneMinusDestinationAlpha  = 0x305
            DestinationColor          = 0x306
            OneMinusDestinationColor  = 0x307
            SourceAlphaSaturate       = 0x308
            ConstantColor             = 0x8001
            OneMinusConstantColor     = 0x8002
            ConstantAlpha             = 0x8003
            OneMinusConstantAlpha     = 0x8004
            OneMinusSource1Alpha      = 0x8005
            OneMinusSource1Color      = 0x8006
            OneMinusSource1Color0     = 0x8006


    class QBlitFramebuffer(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        destinationAttachmentPointChanged: typing.ClassVar[Signal] = ... # destinationAttachmentPointChanged()
        destinationChanged       : typing.ClassVar[Signal] = ... # destinationChanged()
        destinationRectChanged   : typing.ClassVar[Signal] = ... # destinationRectChanged()
        interpolationMethodChanged: typing.ClassVar[Signal] = ... # interpolationMethodChanged()
        sourceAttachmentPointChanged: typing.ClassVar[Signal] = ... # sourceAttachmentPointChanged()
        sourceChanged            : typing.ClassVar[Signal] = ... # sourceChanged()
        sourceRectChanged        : typing.ClassVar[Signal] = ... # sourceRectChanged()

        class InterpolationMethod(enum.Enum):

            Nearest                   = 0x0
            Linear                    = 0x1


    class QBufferCapture(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QCamera(PySide6.Qt3DCore.Qt3DCore.QEntity):

        aspectRatioChanged       : typing.ClassVar[Signal] = ... # aspectRatioChanged(float)
        bottomChanged            : typing.ClassVar[Signal] = ... # bottomChanged(float)
        exposureChanged          : typing.ClassVar[Signal] = ... # exposureChanged(float)
        farPlaneChanged          : typing.ClassVar[Signal] = ... # farPlaneChanged(float)
        fieldOfViewChanged       : typing.ClassVar[Signal] = ... # fieldOfViewChanged(float)
        leftChanged              : typing.ClassVar[Signal] = ... # leftChanged(float)
        nearPlaneChanged         : typing.ClassVar[Signal] = ... # nearPlaneChanged(float)
        positionChanged          : typing.ClassVar[Signal] = ... # positionChanged(QVector3D)
        projectionMatrixChanged  : typing.ClassVar[Signal] = ... # projectionMatrixChanged(QMatrix4x4)
        projectionTypeChanged    : typing.ClassVar[Signal] = ... # projectionTypeChanged(QCameraLens::ProjectionType)
        rightChanged             : typing.ClassVar[Signal] = ... # rightChanged(float)
        topChanged               : typing.ClassVar[Signal] = ... # topChanged(float)
        upVectorChanged          : typing.ClassVar[Signal] = ... # upVectorChanged(QVector3D)
        viewCenterChanged        : typing.ClassVar[Signal] = ... # viewCenterChanged(QVector3D)
        viewMatrixChanged        : typing.ClassVar[Signal] = ... # viewMatrixChanged()
        viewVectorChanged        : typing.ClassVar[Signal] = ... # viewVectorChanged(QVector3D)

        class CameraTranslationOption(enum.Enum):

            TranslateViewCenter       = 0x0
            DontTranslateViewCenter   = 0x1


    class QCameraLens(PySide6.Qt3DCore.Qt3DCore.QComponent):

        aspectRatioChanged       : typing.ClassVar[Signal] = ... # aspectRatioChanged(float)
        bottomChanged            : typing.ClassVar[Signal] = ... # bottomChanged(float)
        exposureChanged          : typing.ClassVar[Signal] = ... # exposureChanged(float)
        farPlaneChanged          : typing.ClassVar[Signal] = ... # farPlaneChanged(float)
        fieldOfViewChanged       : typing.ClassVar[Signal] = ... # fieldOfViewChanged(float)
        leftChanged              : typing.ClassVar[Signal] = ... # leftChanged(float)
        nearPlaneChanged         : typing.ClassVar[Signal] = ... # nearPlaneChanged(float)
        projectionMatrixChanged  : typing.ClassVar[Signal] = ... # projectionMatrixChanged(QMatrix4x4)
        projectionTypeChanged    : typing.ClassVar[Signal] = ... # projectionTypeChanged(QCameraLens::ProjectionType)
        rightChanged             : typing.ClassVar[Signal] = ... # rightChanged(float)
        topChanged               : typing.ClassVar[Signal] = ... # topChanged(float)
        viewSphere               : typing.ClassVar[Signal] = ... # viewSphere(QVector3D,float)

        class ProjectionType(enum.Enum):

            OrthographicProjection    = 0x0
            PerspectiveProjection     = 0x1
            FrustumProjection         = 0x2
            CustomProjection          = 0x3


    class QCameraSelector(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        cameraChanged            : typing.ClassVar[Signal] = ... # cameraChanged(Qt3DCore::QEntity*)

    class QClearBuffers(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        buffersChanged           : typing.ClassVar[Signal] = ... # buffersChanged(BufferType)
        clearColorChanged        : typing.ClassVar[Signal] = ... # clearColorChanged(QColor)
        clearDepthValueChanged   : typing.ClassVar[Signal] = ... # clearDepthValueChanged(float)
        clearStencilValueChanged : typing.ClassVar[Signal] = ... # clearStencilValueChanged(int)
        colorBufferChanged       : typing.ClassVar[Signal] = ... # colorBufferChanged(QRenderTargetOutput*)

        class BufferType(enum.Flag):

            None_                     = 0x0
            ColorBuffer               = 0x1
            DepthBuffer               = 0x2
            ColorDepthBuffer          = 0x3
            StencilBuffer             = 0x4
            DepthStencilBuffer        = 0x6
            ColorDepthStencilBuffer   = 0x7
            AllBuffers                = 0xffffffff


    class QClipPlane(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        distanceChanged          : typing.ClassVar[Signal] = ... # distanceChanged(float)
        normalChanged            : typing.ClassVar[Signal] = ... # normalChanged(QVector3D)
        planeIndexChanged        : typing.ClassVar[Signal] = ... # planeIndexChanged(int)

    class QColorMask(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        alphaMaskedChanged       : typing.ClassVar[Signal] = ... # alphaMaskedChanged(bool)
        blueMaskedChanged        : typing.ClassVar[Signal] = ... # blueMaskedChanged(bool)
        greenMaskedChanged       : typing.ClassVar[Signal] = ... # greenMaskedChanged(bool)
        redMaskedChanged         : typing.ClassVar[Signal] = ... # redMaskedChanged(bool)

    class QComputeCommand(PySide6.Qt3DCore.Qt3DCore.QComponent):

        runTypeChanged           : typing.ClassVar[Signal] = ... # runTypeChanged()
        workGroupXChanged        : typing.ClassVar[Signal] = ... # workGroupXChanged()
        workGroupYChanged        : typing.ClassVar[Signal] = ... # workGroupYChanged()
        workGroupZChanged        : typing.ClassVar[Signal] = ... # workGroupZChanged()

        class RunType(enum.Enum):

            Continuous                = 0x0
            Manual                    = 0x1


    class QCullFace(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        modeChanged              : typing.ClassVar[Signal] = ... # modeChanged(CullingMode)

        class CullingMode(enum.Enum):

            NoCulling                 = 0x0
            Front                     = 0x404
            Back                      = 0x405
            FrontAndBack              = 0x408


    class QDebugOverlay(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QDepthRange(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        farValueChanged          : typing.ClassVar[Signal] = ... # farValueChanged(double)
        nearValueChanged         : typing.ClassVar[Signal] = ... # nearValueChanged(double)

    class QDepthTest(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        depthFunctionChanged     : typing.ClassVar[Signal] = ... # depthFunctionChanged(DepthFunction)

        class DepthFunction(enum.Enum):

            Never                     = 0x200
            Less                      = 0x201
            Equal                     = 0x202
            LessOrEqual               = 0x203
            Greater                   = 0x204
            NotEqual                  = 0x205
            GreaterOrEqual            = 0x206
            Always                    = 0x207


    class QDirectionalLight(PySide6.Qt3DRender.Qt3DRender.QAbstractLight):

        worldDirectionChanged    : typing.ClassVar[Signal] = ... # worldDirectionChanged(QVector3D)

    class QDispatchCompute(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        workGroupXChanged        : typing.ClassVar[Signal] = ... # workGroupXChanged()
        workGroupYChanged        : typing.ClassVar[Signal] = ... # workGroupYChanged()
        workGroupZChanged        : typing.ClassVar[Signal] = ... # workGroupZChanged()

    class QDithering(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QEffect(PySide6.Qt3DCore.Qt3DCore.QNode): ...

    class QEnvironmentLight(PySide6.Qt3DCore.Qt3DCore.QComponent):

        irradianceChanged        : typing.ClassVar[Signal] = ... # irradianceChanged(Qt3DRender::QAbstractTexture*)
        specularChanged          : typing.ClassVar[Signal] = ... # specularChanged(Qt3DRender::QAbstractTexture*)

    class QFilterKey(PySide6.Qt3DCore.Qt3DCore.QNode):

        nameChanged              : typing.ClassVar[Signal] = ... # nameChanged(QString)
        valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(QVariant)

    class QFrameGraphNode(PySide6.Qt3DCore.Qt3DCore.QNode): ...

    class QFrontFace(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        directionChanged         : typing.ClassVar[Signal] = ... # directionChanged(WindingDirection)

        class WindingDirection(enum.Enum):

            ClockWise                 = 0x900
            CounterClockWise          = 0x901


    class QFrustumCulling(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QGeometryRenderer(PySide6.Qt3DCore.Qt3DCore.QBoundingVolume):

        firstInstanceChanged     : typing.ClassVar[Signal] = ... # firstInstanceChanged(int)
        firstVertexChanged       : typing.ClassVar[Signal] = ... # firstVertexChanged(int)
        geometryChanged          : typing.ClassVar[Signal] = ... # geometryChanged(Qt3DCore::QGeometry*)
        indexBufferByteOffsetChanged: typing.ClassVar[Signal] = ... # indexBufferByteOffsetChanged(int)
        indexOffsetChanged       : typing.ClassVar[Signal] = ... # indexOffsetChanged(int)
        instanceCountChanged     : typing.ClassVar[Signal] = ... # instanceCountChanged(int)
        primitiveRestartEnabledChanged: typing.ClassVar[Signal] = ... # primitiveRestartEnabledChanged(bool)
        primitiveTypeChanged     : typing.ClassVar[Signal] = ... # primitiveTypeChanged(PrimitiveType)
        restartIndexValueChanged : typing.ClassVar[Signal] = ... # restartIndexValueChanged(int)
        sortIndexChanged         : typing.ClassVar[Signal] = ... # sortIndexChanged(float)
        vertexCountChanged       : typing.ClassVar[Signal] = ... # vertexCountChanged(int)
        verticesPerPatchChanged  : typing.ClassVar[Signal] = ... # verticesPerPatchChanged(int)

        class PrimitiveType(enum.Enum):

            Points                    = 0x0
            Lines                     = 0x1
            LineLoop                  = 0x2
            LineStrip                 = 0x3
            Triangles                 = 0x4
            TriangleStrip             = 0x5
            TriangleFan               = 0x6
            LinesAdjacency            = 0xa
            LineStripAdjacency        = 0xb
            TrianglesAdjacency        = 0xc
            TriangleStripAdjacency    = 0xd
            Patches                   = 0xe


    class QGraphicsApiFilter(PySide6.QtCore.QObject):

        apiChanged               : typing.ClassVar[Signal] = ... # apiChanged(Qt3DRender::QGraphicsApiFilter::Api)
        extensionsChanged        : typing.ClassVar[Signal] = ... # extensionsChanged(QStringList)
        graphicsApiFilterChanged : typing.ClassVar[Signal] = ... # graphicsApiFilterChanged()
        majorVersionChanged      : typing.ClassVar[Signal] = ... # majorVersionChanged(int)
        minorVersionChanged      : typing.ClassVar[Signal] = ... # minorVersionChanged(int)
        profileChanged           : typing.ClassVar[Signal] = ... # profileChanged(Qt3DRender::QGraphicsApiFilter::OpenGLProfile)
        vendorChanged            : typing.ClassVar[Signal] = ... # vendorChanged(QString)

        class Api(enum.Enum):

            OpenGL                    = 0x1
            OpenGLES                  = 0x2
            Vulkan                    = 0x3
            DirectX                   = 0x4
            RHI                       = 0x5

        class OpenGLProfile(enum.Enum):

            NoProfile                 = 0x0
            CoreProfile               = 0x1
            CompatibilityProfile      = 0x2


    class QLayer(PySide6.Qt3DCore.Qt3DCore.QComponent):

        recursiveChanged         : typing.ClassVar[Signal] = ... # recursiveChanged()

    class QLayerFilter(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        filterModeChanged        : typing.ClassVar[Signal] = ... # filterModeChanged(FilterMode)

        class FilterMode(enum.Enum):

            AcceptAnyMatchingLayers   = 0x0
            AcceptAllMatchingLayers   = 0x1
            DiscardAnyMatchingLayers  = 0x2
            DiscardAllMatchingLayers  = 0x3


    class QLevelOfDetail(PySide6.Qt3DCore.Qt3DCore.QComponent):

        cameraChanged            : typing.ClassVar[Signal] = ... # cameraChanged(QCamera*)
        currentIndexChanged      : typing.ClassVar[Signal] = ... # currentIndexChanged(int)
        thresholdTypeChanged     : typing.ClassVar[Signal] = ... # thresholdTypeChanged(ThresholdType)
        thresholdsChanged        : typing.ClassVar[Signal] = ... # thresholdsChanged(QList<qreal>)
        volumeOverrideChanged    : typing.ClassVar[Signal] = ... # volumeOverrideChanged(QLevelOfDetailBoundingSphere)

        class ThresholdType(enum.Enum):

            DistanceToCameraThreshold = 0x0
            ProjectedScreenPixelSizeThreshold = 0x1


    class QLevelOfDetailBoundingSphere(Shiboken.Object): ...

    class QLevelOfDetailSwitch(PySide6.Qt3DRender.Qt3DRender.QLevelOfDetail): ...

    class QLineWidth(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        smoothChanged            : typing.ClassVar[Signal] = ... # smoothChanged(bool)
        valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(float)

    class QMaterial(PySide6.Qt3DCore.Qt3DCore.QComponent):

        effectChanged            : typing.ClassVar[Signal] = ... # effectChanged(QEffect*)

    class QMemoryBarrier(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        waitOperationsChanged    : typing.ClassVar[Signal] = ... # waitOperationsChanged(QMemoryBarrier::Operations)

        class Operation(enum.Flag):

            None_                     = 0x0
            VertexAttributeArray      = 0x1
            ElementArray              = 0x2
            Uniform                   = 0x4
            TextureFetch              = 0x8
            ShaderImageAccess         = 0x10
            Command                   = 0x20
            PixelBuffer               = 0x40
            TextureUpdate             = 0x80
            BufferUpdate              = 0x100
            FrameBuffer               = 0x200
            TransformFeedback         = 0x400
            AtomicCounter             = 0x800
            ShaderStorage             = 0x1000
            QueryBuffer               = 0x2000
            All                       = 0xffffffff


    class QMesh(PySide6.Qt3DRender.Qt3DRender.QGeometryRenderer):

        meshNameChanged          : typing.ClassVar[Signal] = ... # meshNameChanged(QString)
        sourceChanged            : typing.ClassVar[Signal] = ... # sourceChanged(QUrl)
        statusChanged            : typing.ClassVar[Signal] = ... # statusChanged(Status)

        class Status(enum.Enum):

            None_                     = 0x0
            Loading                   = 0x1
            Ready                     = 0x2
            Error                     = 0x3


    class QMultiSampleAntiAliasing(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QNoDepthMask(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QNoDraw(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QNoPicking(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QObjectPicker(PySide6.Qt3DCore.Qt3DCore.QComponent):

        clicked                  : typing.ClassVar[Signal] = ... # clicked(Qt3DRender::QPickEvent*)
        containsMouseChanged     : typing.ClassVar[Signal] = ... # containsMouseChanged(bool)
        dragEnabledChanged       : typing.ClassVar[Signal] = ... # dragEnabledChanged(bool)
        entered                  : typing.ClassVar[Signal] = ... # entered()
        exited                   : typing.ClassVar[Signal] = ... # exited()
        hoverEnabledChanged      : typing.ClassVar[Signal] = ... # hoverEnabledChanged(bool)
        moved                    : typing.ClassVar[Signal] = ... # moved(Qt3DRender::QPickEvent*)
        pressed                  : typing.ClassVar[Signal] = ... # pressed(Qt3DRender::QPickEvent*)
        pressedChanged           : typing.ClassVar[Signal] = ... # pressedChanged(bool)
        priorityChanged          : typing.ClassVar[Signal] = ... # priorityChanged(int)
        released                 : typing.ClassVar[Signal] = ... # released(Qt3DRender::QPickEvent*)

    class QPaintedTextureImage(PySide6.Qt3DRender.Qt3DRender.QAbstractTextureImage):

        heightChanged            : typing.ClassVar[Signal] = ... # heightChanged(int)
        sizeChanged              : typing.ClassVar[Signal] = ... # sizeChanged(QSize)
        widthChanged             : typing.ClassVar[Signal] = ... # widthChanged(int)

    class QParameter(PySide6.Qt3DCore.Qt3DCore.QNode):

        nameChanged              : typing.ClassVar[Signal] = ... # nameChanged(QString)
        valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(QVariant)

    class QPickEvent(PySide6.QtCore.QObject):

        acceptedChanged          : typing.ClassVar[Signal] = ... # acceptedChanged(bool)

        class Buttons(enum.Enum):

            NoButton                  = 0x0
            LeftButton                = 0x1
            RightButton               = 0x2
            MiddleButton              = 0x4
            BackButton                = 0x8

        class Modifiers(enum.Enum):

            NoModifier                = 0x0
            ShiftModifier             = 0x2000000
            ControlModifier           = 0x4000000
            AltModifier               = 0x8000000
            MetaModifier              = 0x10000000
            KeypadModifier            = 0x20000000


    class QPickLineEvent(PySide6.Qt3DRender.Qt3DRender.QPickEvent): ...

    class QPickPointEvent(PySide6.Qt3DRender.Qt3DRender.QPickEvent): ...

    class QPickTriangleEvent(PySide6.Qt3DRender.Qt3DRender.QPickEvent): ...

    class QPickingProxy(PySide6.Qt3DCore.Qt3DCore.QBoundingVolume): ...

    class QPickingSettings(PySide6.Qt3DCore.Qt3DCore.QNode):

        faceOrientationPickingModeChanged: typing.ClassVar[Signal] = ... # faceOrientationPickingModeChanged(QPickingSettings::FaceOrientationPickingMode)
        pickMethodChanged        : typing.ClassVar[Signal] = ... # pickMethodChanged(QPickingSettings::PickMethod)
        pickResultModeChanged    : typing.ClassVar[Signal] = ... # pickResultModeChanged(QPickingSettings::PickResultMode)
        worldSpaceToleranceChanged: typing.ClassVar[Signal] = ... # worldSpaceToleranceChanged(float)

        class FaceOrientationPickingMode(enum.Enum):

            FrontFace                 = 0x1
            BackFace                  = 0x2
            FrontAndBackFace          = 0x3

        class PickMethod(enum.Enum):

            BoundingVolumePicking     = 0x0
            TrianglePicking           = 0x1
            LinePicking               = 0x2
            PointPicking              = 0x4
            PrimitivePicking          = 0x7

        class PickResultMode(enum.Enum):

            NearestPick               = 0x0
            AllPicks                  = 0x1
            NearestPriorityPick       = 0x2


    class QPointLight(PySide6.Qt3DRender.Qt3DRender.QAbstractLight):

        constantAttenuationChanged: typing.ClassVar[Signal] = ... # constantAttenuationChanged(float)
        linearAttenuationChanged : typing.ClassVar[Signal] = ... # linearAttenuationChanged(float)
        quadraticAttenuationChanged: typing.ClassVar[Signal] = ... # quadraticAttenuationChanged(float)

    class QPointSize(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        sizeModeChanged          : typing.ClassVar[Signal] = ... # sizeModeChanged(SizeMode)
        valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(float)

        class SizeMode(enum.Enum):

            Fixed                     = 0x0
            Programmable              = 0x1


    class QPolygonOffset(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        depthStepsChanged        : typing.ClassVar[Signal] = ... # depthStepsChanged(float)
        scaleFactorChanged       : typing.ClassVar[Signal] = ... # scaleFactorChanged(float)

    class QProximityFilter(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        distanceThresholdChanged : typing.ClassVar[Signal] = ... # distanceThresholdChanged(float)
        entityChanged            : typing.ClassVar[Signal] = ... # entityChanged(Qt3DCore::QEntity*)

    class QRasterMode(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        faceModeChanged          : typing.ClassVar[Signal] = ... # faceModeChanged(FaceMode)
        rasterModeChanged        : typing.ClassVar[Signal] = ... # rasterModeChanged(RasterMode)

        class FaceMode(enum.Enum):

            Front                     = 0x404
            Back                      = 0x405
            FrontAndBack              = 0x408

        class RasterMode(enum.Enum):

            Points                    = 0x1b00
            Lines                     = 0x1b01
            Fill                      = 0x1b02


    class QRayCaster(PySide6.Qt3DRender.Qt3DRender.QAbstractRayCaster):

        directionChanged         : typing.ClassVar[Signal] = ... # directionChanged(QVector3D)
        lengthChanged            : typing.ClassVar[Signal] = ... # lengthChanged(float)
        originChanged            : typing.ClassVar[Signal] = ... # originChanged(QVector3D)

    class QRayCasterHit(Shiboken.Object):

        class HitType(enum.Enum):

            TriangleHit               = 0x0
            LineHit                   = 0x1
            PointHit                  = 0x2
            EntityHit                 = 0x3


    class QRenderAspect(PySide6.Qt3DCore.Qt3DCore.QAbstractAspect):

        class SubmissionType(enum.Enum):

            Automatic                 = 0x0
            Manual                    = 0x1


    class QRenderCapabilities(PySide6.QtCore.QObject):

        class API(enum.Enum):

            OpenGL                    = 0x1
            OpenGLES                  = 0x2
            Vulkan                    = 0x3
            DirectX                   = 0x4
            RHI                       = 0x5

        class Profile(enum.Enum):

            NoProfile                 = 0x0
            CoreProfile               = 0x1
            CompatibilityProfile      = 0x2


    class QRenderCapture(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QRenderCaptureReply(PySide6.QtCore.QObject):

        completed                : typing.ClassVar[Signal] = ... # completed()

    class QRenderPass(PySide6.Qt3DCore.Qt3DCore.QNode):

        shaderProgramChanged     : typing.ClassVar[Signal] = ... # shaderProgramChanged(QShaderProgram*)

    class QRenderPassFilter(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QRenderSettings(PySide6.Qt3DCore.Qt3DCore.QComponent):

        activeFrameGraphChanged  : typing.ClassVar[Signal] = ... # activeFrameGraphChanged(QFrameGraphNode*)
        renderPolicyChanged      : typing.ClassVar[Signal] = ... # renderPolicyChanged(RenderPolicy)

        class RenderPolicy(enum.Enum):

            OnDemand                  = 0x0
            Always                    = 0x1


    class QRenderState(PySide6.Qt3DCore.Qt3DCore.QNode): ...

    class QRenderStateSet(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QRenderSurfaceSelector(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        externalRenderTargetSizeChanged: typing.ClassVar[Signal] = ... # externalRenderTargetSizeChanged(QSize)
        surfaceChanged           : typing.ClassVar[Signal] = ... # surfaceChanged(QObject*)
        surfacePixelRatioChanged : typing.ClassVar[Signal] = ... # surfacePixelRatioChanged(float)

    class QRenderTarget(PySide6.Qt3DCore.Qt3DCore.QComponent): ...

    class QRenderTargetOutput(PySide6.Qt3DCore.Qt3DCore.QNode):

        attachmentPointChanged   : typing.ClassVar[Signal] = ... # attachmentPointChanged(AttachmentPoint)
        faceChanged              : typing.ClassVar[Signal] = ... # faceChanged(QAbstractTexture::CubeMapFace)
        layerChanged             : typing.ClassVar[Signal] = ... # layerChanged(int)
        mipLevelChanged          : typing.ClassVar[Signal] = ... # mipLevelChanged(int)
        textureChanged           : typing.ClassVar[Signal] = ... # textureChanged(QAbstractTexture*)

        class AttachmentPoint(enum.Enum):

            Color0                    = 0x0
            Color1                    = 0x1
            Color2                    = 0x2
            Color3                    = 0x3
            Color4                    = 0x4
            Color5                    = 0x5
            Color6                    = 0x6
            Color7                    = 0x7
            Color8                    = 0x8
            Color9                    = 0x9
            Color10                   = 0xa
            Color11                   = 0xb
            Color12                   = 0xc
            Color13                   = 0xd
            Color14                   = 0xe
            Color15                   = 0xf
            Depth                     = 0x10
            Stencil                   = 0x11
            DepthStencil              = 0x12
            Left                      = 0x13
            Right                     = 0x14


    class QRenderTargetSelector(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        targetChanged            : typing.ClassVar[Signal] = ... # targetChanged(QRenderTarget*)

    class QSceneLoader(PySide6.Qt3DCore.Qt3DCore.QComponent):

        sourceChanged            : typing.ClassVar[Signal] = ... # sourceChanged(QUrl)
        statusChanged            : typing.ClassVar[Signal] = ... # statusChanged(Status)

        class ComponentType(enum.Enum):

            UnknownComponent          = 0x0
            GeometryRendererComponent = 0x1
            TransformComponent        = 0x2
            MaterialComponent         = 0x3
            LightComponent            = 0x4
            CameraLensComponent       = 0x5

        class Status(enum.Enum):

            None_                     = 0x0
            Loading                   = 0x1
            Ready                     = 0x2
            Error                     = 0x3


    class QScissorTest(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        bottomChanged            : typing.ClassVar[Signal] = ... # bottomChanged(int)
        heightChanged            : typing.ClassVar[Signal] = ... # heightChanged(int)
        leftChanged              : typing.ClassVar[Signal] = ... # leftChanged(int)
        widthChanged             : typing.ClassVar[Signal] = ... # widthChanged(int)

    class QScreenRayCaster(PySide6.Qt3DRender.Qt3DRender.QAbstractRayCaster):

        positionChanged          : typing.ClassVar[Signal] = ... # positionChanged(QPoint)

    class QSeamlessCubemap(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QSetFence(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        handleChanged            : typing.ClassVar[Signal] = ... # handleChanged(QVariant)
        handleTypeChanged        : typing.ClassVar[Signal] = ... # handleTypeChanged(HandleType)

        class HandleType(enum.Enum):

            NoHandle                  = 0x0
            OpenGLFenceId             = 0x1


    class QShaderData(PySide6.Qt3DCore.Qt3DCore.QComponent): ...

    class QShaderImage(PySide6.Qt3DCore.Qt3DCore.QNode):

        accessChanged            : typing.ClassVar[Signal] = ... # accessChanged(Access)
        formatChanged            : typing.ClassVar[Signal] = ... # formatChanged(ImageFormat)
        layerChanged             : typing.ClassVar[Signal] = ... # layerChanged(int)
        layeredChanged           : typing.ClassVar[Signal] = ... # layeredChanged(bool)
        mipLevelChanged          : typing.ClassVar[Signal] = ... # mipLevelChanged(int)
        textureChanged           : typing.ClassVar[Signal] = ... # textureChanged(Qt3DRender::QAbstractTexture*)

        class Access(enum.Enum):

            ReadOnly                  = 0x0
            WriteOnly                 = 0x1
            ReadWrite                 = 0x2

        class ImageFormat(enum.Enum):

            NoFormat                  = 0x0
            Automatic                 = 0x1
            RGBA8_UNorm               = 0x8058
            RGB10A2                   = 0x8059
            RGBA16_UNorm              = 0x805b
            R8_UNorm                  = 0x8229
            R16_UNorm                 = 0x822a
            RG8_UNorm                 = 0x822b
            RG16_UNorm                = 0x822c
            R16F                      = 0x822d
            R32F                      = 0x822e
            RG16F                     = 0x822f
            RG32F                     = 0x8230
            R8I                       = 0x8231
            R8U                       = 0x8232
            R16I                      = 0x8233
            R16U                      = 0x8234
            R32I                      = 0x8235
            R32U                      = 0x8236
            RG8I                      = 0x8237
            RG8U                      = 0x8238
            RG16I                     = 0x8239
            RG16U                     = 0x823a
            RG32I                     = 0x823b
            RG32U                     = 0x823c
            RGBA32F                   = 0x8814
            RGBA16F                   = 0x881a
            RG11B10F                  = 0x8c3a
            RGBA32U                   = 0x8d70
            RGBA16U                   = 0x8d76
            RGBA8U                    = 0x8d7c
            RGBA32I                   = 0x8d82
            RGBA16I                   = 0x8d88
            RGBA8I                    = 0x8d8e
            R8_SNorm                  = 0x8f94
            RG8_SNorm                 = 0x8f95
            RGBA8_SNorm               = 0x8f97
            R16_SNorm                 = 0x8f98
            RG16_SNorm                = 0x8f99
            RGBA16_SNorm              = 0x8f9b
            RGB10A2U                  = 0x906f


    class QShaderProgram(PySide6.Qt3DCore.Qt3DCore.QNode):

        computeShaderCodeChanged : typing.ClassVar[Signal] = ... # computeShaderCodeChanged(QByteArray)
        formatChanged            : typing.ClassVar[Signal] = ... # formatChanged(Format)
        fragmentShaderCodeChanged: typing.ClassVar[Signal] = ... # fragmentShaderCodeChanged(QByteArray)
        geometryShaderCodeChanged: typing.ClassVar[Signal] = ... # geometryShaderCodeChanged(QByteArray)
        logChanged               : typing.ClassVar[Signal] = ... # logChanged(QString)
        statusChanged            : typing.ClassVar[Signal] = ... # statusChanged(Status)
        tessellationControlShaderCodeChanged: typing.ClassVar[Signal] = ... # tessellationControlShaderCodeChanged(QByteArray)
        tessellationEvaluationShaderCodeChanged: typing.ClassVar[Signal] = ... # tessellationEvaluationShaderCodeChanged(QByteArray)
        vertexShaderCodeChanged  : typing.ClassVar[Signal] = ... # vertexShaderCodeChanged(QByteArray)

        class Format(enum.Enum):

            GLSL                      = 0x0
            SPIRV                     = 0x1

        class ShaderType(enum.Enum):

            Vertex                    = 0x0
            Fragment                  = 0x1
            TessellationControl       = 0x2
            TessellationEvaluation    = 0x3
            Geometry                  = 0x4
            Compute                   = 0x5

        class Status(enum.Enum):

            NotReady                  = 0x0
            Ready                     = 0x1
            Error                     = 0x2


    class QShaderProgramBuilder(PySide6.Qt3DCore.Qt3DCore.QNode):

        computeShaderCodeChanged : typing.ClassVar[Signal] = ... # computeShaderCodeChanged(QByteArray)
        computeShaderGraphChanged: typing.ClassVar[Signal] = ... # computeShaderGraphChanged(QUrl)
        enabledLayersChanged     : typing.ClassVar[Signal] = ... # enabledLayersChanged(QStringList)
        fragmentShaderCodeChanged: typing.ClassVar[Signal] = ... # fragmentShaderCodeChanged(QByteArray)
        fragmentShaderGraphChanged: typing.ClassVar[Signal] = ... # fragmentShaderGraphChanged(QUrl)
        geometryShaderCodeChanged: typing.ClassVar[Signal] = ... # geometryShaderCodeChanged(QByteArray)
        geometryShaderGraphChanged: typing.ClassVar[Signal] = ... # geometryShaderGraphChanged(QUrl)
        shaderProgramChanged     : typing.ClassVar[Signal] = ... # shaderProgramChanged(Qt3DRender::QShaderProgram*)
        tessellationControlShaderCodeChanged: typing.ClassVar[Signal] = ... # tessellationControlShaderCodeChanged(QByteArray)
        tessellationControlShaderGraphChanged: typing.ClassVar[Signal] = ... # tessellationControlShaderGraphChanged(QUrl)
        tessellationEvaluationShaderCodeChanged: typing.ClassVar[Signal] = ... # tessellationEvaluationShaderCodeChanged(QByteArray)
        tessellationEvaluationShaderGraphChanged: typing.ClassVar[Signal] = ... # tessellationEvaluationShaderGraphChanged(QUrl)
        vertexShaderCodeChanged  : typing.ClassVar[Signal] = ... # vertexShaderCodeChanged(QByteArray)
        vertexShaderGraphChanged : typing.ClassVar[Signal] = ... # vertexShaderGraphChanged(QUrl)

    class QSharedGLTexture(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture):

        textureIdChanged         : typing.ClassVar[Signal] = ... # textureIdChanged(int)

    class QSortPolicy(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        sortTypesChanged         : typing.ClassVar[Signal] = ... # sortTypesChanged(QList<SortType>); sortTypesChanged(QList<int>)

        class SortType(enum.Enum):

            StateChangeCost           = 0x1
            BackToFront               = 0x2
            Material                  = 0x4
            FrontToBack               = 0x8
            Texture                   = 0x10
            Uniform                   = 0x20


    class QSpotLight(PySide6.Qt3DRender.Qt3DRender.QAbstractLight):

        constantAttenuationChanged: typing.ClassVar[Signal] = ... # constantAttenuationChanged(float)
        cutOffAngleChanged       : typing.ClassVar[Signal] = ... # cutOffAngleChanged(float)
        linearAttenuationChanged : typing.ClassVar[Signal] = ... # linearAttenuationChanged(float)
        localDirectionChanged    : typing.ClassVar[Signal] = ... # localDirectionChanged(QVector3D)
        quadraticAttenuationChanged: typing.ClassVar[Signal] = ... # quadraticAttenuationChanged(float)

    class QStencilMask(PySide6.Qt3DRender.Qt3DRender.QRenderState):

        backOutputMaskChanged    : typing.ClassVar[Signal] = ... # backOutputMaskChanged(uint)
        frontOutputMaskChanged   : typing.ClassVar[Signal] = ... # frontOutputMaskChanged(uint)

    class QStencilOperation(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QStencilOperationArguments(PySide6.QtCore.QObject):

        allTestsPassOperationChanged: typing.ClassVar[Signal] = ... # allTestsPassOperationChanged(Operation)
        depthTestFailureOperationChanged: typing.ClassVar[Signal] = ... # depthTestFailureOperationChanged(Operation)
        faceModeChanged          : typing.ClassVar[Signal] = ... # faceModeChanged(FaceMode)
        stencilTestFailureOperationChanged: typing.ClassVar[Signal] = ... # stencilTestFailureOperationChanged(Operation)

        class FaceMode(enum.Enum):

            Front                     = 0x404
            Back                      = 0x405
            FrontAndBack              = 0x408

        class Operation(enum.Enum):

            Zero                      = 0x0
            Invert                    = 0x150a
            Keep                      = 0x1e00
            Replace                   = 0x1e01
            Increment                 = 0x1e02
            Decrement                 = 0x1e03
            IncrementWrap             = 0x8507
            DecrementWrap             = 0x8508


    class QStencilTest(PySide6.Qt3DRender.Qt3DRender.QRenderState): ...

    class QStencilTestArguments(PySide6.QtCore.QObject):

        comparisonMaskChanged    : typing.ClassVar[Signal] = ... # comparisonMaskChanged(uint)
        faceModeChanged          : typing.ClassVar[Signal] = ... # faceModeChanged(StencilFaceMode)
        referenceValueChanged    : typing.ClassVar[Signal] = ... # referenceValueChanged(int)
        stencilFunctionChanged   : typing.ClassVar[Signal] = ... # stencilFunctionChanged(StencilFunction)

        class StencilFaceMode(enum.Enum):

            Front                     = 0x404
            Back                      = 0x405
            FrontAndBack              = 0x408

        class StencilFunction(enum.Enum):

            Never                     = 0x200
            Less                      = 0x201
            Equal                     = 0x202
            LessOrEqual               = 0x203
            Greater                   = 0x204
            NotEqual                  = 0x205
            GreaterOrEqual            = 0x206
            Always                    = 0x207


    class QSubtreeEnabler(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        enablementChanged        : typing.ClassVar[Signal] = ... # enablementChanged(Qt3DRender::QSubtreeEnabler::Enablement)

        class Enablement(enum.Enum):

            Persistent                = 0x0
            SingleShot                = 0x1


    class QTechnique(PySide6.Qt3DCore.Qt3DCore.QNode): ...

    class QTechniqueFilter(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode): ...

    class QTexture1D(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTexture1DArray(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTexture2D(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTexture2DArray(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTexture2DMultisample(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTexture2DMultisampleArray(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTexture3D(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTextureBuffer(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTextureCubeMap(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTextureCubeMapArray(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTextureData(Shiboken.Object): ...

    class QTextureDataUpdate(Shiboken.Object): ...

    class QTextureImage(PySide6.Qt3DRender.Qt3DRender.QAbstractTextureImage):

        mirroredChanged          : typing.ClassVar[Signal] = ... # mirroredChanged(bool)
        sourceChanged            : typing.ClassVar[Signal] = ... # sourceChanged(QUrl)
        statusChanged            : typing.ClassVar[Signal] = ... # statusChanged(Status)

        class Status(enum.Enum):

            None_                     = 0x0
            Loading                   = 0x1
            Ready                     = 0x2
            Error                     = 0x3


    class QTextureImageData(Shiboken.Object): ...

    class QTextureImageDataGenerator(PySide6.Qt3DCore.Qt3DCore.QAbstractFunctor): ...

    class QTextureImageDataGeneratorPtr(Shiboken.Object): ...
        def __dir__(self, /) -> collections.abc.Iterable[str]: ...
        def __repr__(self, /) -> str: ...

    class QTextureImageDataPtr(Shiboken.Object): ...
        def __dir__(self, /) -> collections.abc.Iterable[str]: ...
        def __repr__(self, /) -> str: ...

    class QTextureLoader(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture):

        mirroredChanged          : typing.ClassVar[Signal] = ... # mirroredChanged(bool)
        sourceChanged            : typing.ClassVar[Signal] = ... # sourceChanged(QUrl)

    class QTextureRectangle(PySide6.Qt3DRender.Qt3DRender.QAbstractTexture): ...

    class QTextureWrapMode(PySide6.QtCore.QObject):

        xChanged                 : typing.ClassVar[Signal] = ... # xChanged(WrapMode)
        yChanged                 : typing.ClassVar[Signal] = ... # yChanged(WrapMode)
        zChanged                 : typing.ClassVar[Signal] = ... # zChanged(WrapMode)

        class WrapMode(enum.Enum):

            Repeat                    = 0x2901
            ClampToBorder             = 0x812d
            ClampToEdge               = 0x812f
            MirroredRepeat            = 0x8370


    class QViewport(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        gammaChanged             : typing.ClassVar[Signal] = ... # gammaChanged(float)
        normalizedRectChanged    : typing.ClassVar[Signal] = ... # normalizedRectChanged(QRectF)

    class QWaitFence(PySide6.Qt3DRender.Qt3DRender.QFrameGraphNode):

        handleChanged            : typing.ClassVar[Signal] = ... # handleChanged(QVariant)
        handleTypeChanged        : typing.ClassVar[Signal] = ... # handleTypeChanged(HandleType)
        timeoutChanged           : typing.ClassVar[Signal] = ... # timeoutChanged(qulonglong)
        waitOnCPUChanged         : typing.ClassVar[Signal] = ... # waitOnCPUChanged(bool)

        class HandleType(enum.Enum):

            NoHandle                  = 0x0
            OpenGLFenceId             = 0x1


# eof
